using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using MySql.Data.MySqlClient;


namespace lr3
{
    public partial class Form17 : Form
    {
        public void disable_components(Control[] c) //блокує пакетно передані візуальні компоненти
        {
            foreach (Control e in c) e.Enabled = false; //перебираємо через змінну e компоненти та блокуємо їх
        }

        public void enable_components(Control[] c) //розблоковує пакетно передані компоненти
        {
            foreach (Control e in c) e.Enabled = true; //перебираємо через змінну e компоненти та розблоковуємо їх
        }

        public void hide_components(Control[] c) //ховаємо пакетно передані компоненти
        {
            foreach (Control e in c) e.Visible = false;//перебираємо через змінну е компоненти та ховаємо їх
        }

        public void show_components(Control[] c) //показуємо пакетно передані компоненти
        {
            foreach (Control e in c) e.Visible = true;//перебираємо через змінну е компоненти та показуємо їх
        }

        public bool alert_message(string msg, string cap) //показує повідомлення і повертає істину, якщо натиснута кнопка так
        {
            //показуємо повідомлення msg із заголовком cap і якщо відповідь так тоді повертаемо істину
            if (MessageBox.Show(msg, cap, MessageBoxButtons.YesNo) == DialogResult.Yes) return true;
            return false;//в іншому випадку повертаємо хибність
        }

        private MySqlConnection con;
        public Form17(MySqlConnection c)
        {
            InitializeComponent();
            con = c;
            tabControl1.SelectedIndex = 0;
            fill_grid("SELECT `zaholovky_postach`.`id`," +
                        "`providers`.`Name` as 'providers', `personal`.`Name` as 'personal',`zaholovky_postach`.`summ`,`zaholovky_postach`.`data`, " +
                        "`providers`.`id` as 'bid', " +
                        "`personal`.`id` as 'pid' FROM `zaholovky_postach` " +

                        "JOIN `providers` on `providers`.`id`=`zaholovky_postach`.`id_provider` " +

                        "JOIN `personal` on `personal`.`id`=`zaholovky_postach`.`id_personal`;", dataGridView1,

            new string[] { "bid", "pid", "id" },//перелічуємо назви стовпців, які потрібно приховати

                 new string[] { "providers", "personal", "summ", "data" },//перелічуємо назви стовпців транслітом
                 new string[] { "Постачальники", "Співробітник", "Сума", "Дата" });

            fill_combobox("SELECT * FROM `providers`;", "id", "Name", comboBox1);
            fill_combobox("SELECT * FROM `personal`;", "id", "Name", comboBox2);
            fill_combobox("SELECT * FROM `providers`;", "id", "Name", comboBox3);
            fill_combobox("SELECT * FROM `personal`;", "id", "Name", comboBox4);
            fill_combobox("SELECT * FROM `materialy`;", "id", "material", comboBox5);
            fill_combobox("SELECT * FROM `materialy`;", "id", "material", comboBox6);

        }
        private void fill_grid(string q, DataGridView d, string[] f, string[] wn, string[] nn)
        { //Виконуємо запит і відображаємо результат на сітці та ховаємо у відображенні стовпці f
            //та переіменовуємо стовпці wn в nn
            fill_grid(q, d, f); // викликаємо перевантажену функцію яка заповнює сітку та ховає "непотрібні" поля
            for (int i = 0; i <= wn.Length - 1; i++)
            { //перебираємо кожне значення в wn
                d.Columns[wn[i]].HeaderText = nn[i];//присвоюємо стовпцю з назвою елемента wn нову назву з nn
            }

        }

        //=-=-=-=-=-=-=-= Перше перевантаження функції (тільки приховуємо)
        private void fill_grid(string q, DataGridView d, string[] f)
        { //Виконуємо запит і відображаємо результат на сітці та ховаємо у відображенні стовпці f
            fill_grid(q, d);//викликаємо перевантажену функцію, яка заповнює сітку
            foreach (string fn in f) //перебераємо всі значення f
            {
                d.Columns[fn].Visible = false;//ховаємо заданий стовпець
            }
        }

        public void fill_combobox(string q, string f_id, string f_name, ComboBox c)
        {
            DataGridView dgv = new DataGridView() { Parent = this, Visible = false };
            fill_grid(q, dgv);
            c.DataSource = null;
            c.Items.Clear();
            Dictionary<string, string> comboSource = new Dictionary<string, string>();
            foreach (DataGridViewRow r in dgv.Rows)
            {
                comboSource.Add(r.Cells[f_id].Value + "", r.Cells[f_name].Value + "");
            }
            c.DataSource = new BindingSource(comboSource, null);
            c.DisplayMember = "Value";
            c.ValueMember = "Key";
            c.Text = "";
        }

        private void fill_grid(string q, DataGridView d)
        {
            DataTable dt = new DataTable();
            if (con.State.ToString() != "Open") con.Open();
            MySqlCommand com = new MySqlCommand(q, con);
            MySqlDataReader dr = com.ExecuteReader();
            dt.Load(dr);
            d.DataSource = dt;
            dr.Close();
        }

        private Int32 read_integer_data(string q)
        {
            Int32 result = 0;
            if (con.State.ToString() != "Open") con.Open();
            MySqlCommand com = new MySqlCommand(q, con);
            MySqlDataReader dr = com.ExecuteReader();
            if (dr.HasRows)
            {
                dr.Read();
                result = dr.GetInt32(0);
            }
            dr.Close();
            return result;
        }

        private void run_query(string q)
        {
            if (con.State.ToString() != "Open") con.Open();
            MySqlCommand com = new MySqlCommand(q, con);
            com.ExecuteNonQuery();
        }

        private void button3_Click(object sender, EventArgs e)
        {
            string id = dataGridView1.Rows[dataGridView1.CurrentRow.Index].Cells["id"].Value + "";
            string p_id = comboBox3.SelectedValue + "";
            if (p_id == "") p_id = "0";
            string c_id = comboBox4.SelectedValue + "";
            if (c_id == "") c_id = "0";

            string data = textBox2.Text; string summ = textBox8.Text;
            data = Convert.ToDateTime(data).ToString("yyyy-MM-dd");
            run_query("UPDATE `zaholovky_postach` SET `id_provider`='" + p_id + "',`id_personal`='" + c_id + "',`data`='" + data + "',`summ`='" + summ + "'WHERE `id`=" + id + "");
            fill_grid("SELECT `zaholovky_postach`.`id`," +
                         "`providers`.`Name` as 'providers', `personal`.`Name` as 'personal',`zaholovky_postach`.`summ`,`zaholovky_postach`.`data`, " +
                         "`providers`.`id` as 'bid', " +
                         "`personal`.`id` as 'pid' FROM `zaholovky_postach` " +

                         "JOIN `providers` on `providers`.`id`=`zaholovky_postach`.`id_provider` " +

                         "JOIN `personal` on `personal`.`id`=`zaholovky_postach`.`id_personal`;", dataGridView1,

             new string[] { "bid", "pid", "id" },//перелічуємо назви стовпців, які потрібно приховати

                  new string[] { "providers", "personal", "summ", "data" },//перелічуємо назви стовпців транслітом
                  new string[] { "Постачальники", "Співробітник", "Сума", "Дата" });
            button4_Click(this, null);
        }

        private void button1_Click(object sender, EventArgs e)
        {


            string c_id = comboBox1.SelectedValue + "";
            if (c_id == "") c_id = "0";
            string s_id = comboBox2.SelectedValue + "";
            if (s_id == "") s_id = "0";
            string summ = textBox7.Text + "";
            string data = textBox1.Text + "";
            run_query("INSERT INTO `zaholovky_postach` VALUES (NULL,'" + c_id + "','" + s_id + "','" + data + "','" + summ + "');");
            fill_grid("SELECT `zaholovky_postach`.`id`," +
                         "`providers`.`Name` as 'providers', `personal`.`Name` as 'personal',`zaholovky_postach`.`summ`,`zaholovky_postach`.`data`, " +
                         "`providers`.`id` as 'bid', " +
                         "`personal`.`id` as 'pid' FROM `zaholovky_postach` " +

                         "JOIN `providers` on `providers`.`id`=`zaholovky_postach`.`id_provider` " +

                         "JOIN `personal` on `personal`.`id`=`zaholovky_postach`.`id_personal`;", dataGridView1,

             new string[] { "bid", "pid", "id" },//перелічуємо назви стовпців, які потрібно приховати

                  new string[] { "providers", "personal", "summ", "data" },//перелічуємо назви стовпців транслітом
                  new string[] { "Постачальники", "Співробітник", "Сума", "Дата" });
            comboBox1.Text = ""; comboBox2.Text = ""; textBox7.Text = ""; textBox1.Text = "";
            button2_Click(this, null);
        }

        private void button2_Click(object sender, EventArgs e)
        {
            enable_components(new Control[] { dataGridView2, dataGridView1, tabControl2, tabPage2 });
        }

        private void dataGridView1_CellContentClick(object sender, DataGridViewCellEventArgs e)
        {
            string id = dataGridView1.Rows[dataGridView1.CurrentRow.Index].Cells["id"].Value + "";
            fill_grid("SELECT `punkty_postach`.`id`," +
                       " `materialy`.`material` as 'material',`punkty_postach`.`kilkist`,`punkty_postach`.`price`, " +
                       "`materialy`.`id` as 'mid', " +
                       " `punkty_postach`.`id_zaholovky_postach` from `punkty_postach` " +


                       "JOIN `materialy` on `materialy`.`id`=`punkty_postach`.`id_materialy` " +
                       "WHERE `punkty_postach`.`id_zaholovky_postach` = " + id, dataGridView2,

           new string[] { "mid", "id_zaholovky_postach", "id" },//перелічуємо назви стовпців, які потрібно приховати

                new string[] { "material", "kilkist", "price" },//перелічуємо назви стовпців транслітом
                new string[] { "Матеріал", "Кількість", "Ціна" });
        }

        private void button5_Click(object sender, EventArgs e)
        {
            string id_zaholovky_postach = dataGridView1.Rows[dataGridView1.CurrentRow.Index].Cells["id"].Value + "";
            string m_id = comboBox5.SelectedValue + "";
            if (m_id == "") m_id = "0";
            string kilkist = textBox3.Text;
            string price = textBox4.Text;

            Int32 new_kilkist = Convert.ToInt32(kilkist);

            Int32 sklad_kilk = read_integer_data("SELECT COALESCE( sum(`sklad`.`kilkist`), 0) as `kilkist` from `sklad` where `sklad`.`id_materialy` = '" + m_id + "'");

            Int32 zalyshok = sklad_kilk + new_kilkist;

            if (zalyshok < 0)
            {
                run_query("INSERT INTO `sklad` VALUES (NULL,'" + m_id + "','" + kilkist + "');");

            }

            run_query("INSERT INTO `punkty_postach` VALUES (NULL, '" + id_zaholovky_postach + "','" + m_id + "','" + price + "','" + kilkist + "');");
            run_query("UPDATE  `sklad` SET `kilkist`='" + zalyshok.ToString() + "' WHERE `id_materialy`=" + m_id + ";");

            fill_grid("SELECT `punkty_postach`.`id`," +
                       " `materialy`.`material` as 'material',`punkty_postach`.`price`,`punkty_postach`.`kilkist`, " +
                       "`materialy`.`id` as 'm_id', " +
                       " `punkty_postach`.`id_zaholovky_postach` from `punkty_postach` " +


                       "JOIN `materialy` on `materialy`.`id`=`punkty_postach`.`id_materialy` " +
                        "WHERE `punkty_postach`.`id_zaholovky_postach` = " + id_zaholovky_postach, dataGridView2,

           new string[] { "m_id", "id_zaholovky_postach", "id" },//перелічуємо назви стовпців, які потрібно приховати

                new string[] { "material", "price", "kilkist" },//перелічуємо назви стовпців транслітом
                new string[] { "Матеріал", "Ціна", "Кількість" });
            comboBox5.Text = ""; textBox3.Text = ""; textBox4.Text = "";

            button6_Click(this, null);
        }

        private void button6_Click(object sender, EventArgs e)
        {
            comboBox5.Text = ""; textBox3.Text = ""; textBox4.Text = "";
            enable_components(new Control[] { dataGridView2, dataGridView1, tabControl1, tabPage2, });
        }

        private void button4_Click(object sender, EventArgs e)
        {
            comboBox3.Text = ""; comboBox4.Text = ""; textBox2.Text = ""; textBox8.Text = "";
            tabControl1.SelectedIndex = 0;//перемикаємо на вкладку додати
            enable_components(new Control[] { dataGridView1, tabControl2, tabPage2, tabPage1 });
        }

        private void редагуватиToolStripMenuItem_Click(object sender, EventArgs e)
        {

            comboBox3.Text = dataGridView1.Rows[dataGridView1.CurrentRow.Index].Cells["providers"].Value + "";
            comboBox4.Text = dataGridView1.Rows[dataGridView1.CurrentRow.Index].Cells["personal"].Value + "";
            textBox2.Text = dataGridView1.Rows[dataGridView1.CurrentRow.Index].Cells["data"].Value + "";
            textBox8.Text = dataGridView1.Rows[dataGridView1.CurrentRow.Index].Cells["summ"].Value + "";
            show_components(new Control[] { tabControl1 }); //(1)
            disable_components(new Control[] { dataGridView1, tabControl2, tabPage1 });//(2)
            tabControl1.SelectedIndex = 1;
        }

        private void додатиToolStripMenuItem1_Click(object sender, EventArgs e)
        {
            show_components(new Control[] { tabControl2, tabPage1 });//показуємо панель вкладок, та кнопку відмінити редагування
            disable_components(new Control[] { dataGridView2, dataGridView1, tabControl1, tabPage2 });//блокуємо сітку, вкладку редагувати, панель пошуку
        }

        private void редагуватиToolStripMenuItem1_Click(object sender, EventArgs e)
        {
            comboBox6.Text = dataGridView2.Rows[dataGridView2.CurrentRow.Index].Cells["material"].Value + "";
            textBox5.Text = dataGridView2.Rows[dataGridView2.CurrentRow.Index].Cells["kilkist"].Value + "";
            textBox6.Text = dataGridView2.Rows[dataGridView2.CurrentRow.Index].Cells["price"].Value + "";
            show_components(new Control[] { tabControl2 }); //(1)
            disable_components(new Control[] { dataGridView2, dataGridView1,tabControl1, tabPage1 });//(2)

            tabControl2.SelectedIndex = 1;
            tabControl1.SelectedIndex = 1;
        }

        private void button7_Click(object sender, EventArgs e)
        {
            string id = dataGridView2.Rows[dataGridView2.CurrentRow.Index].Cells["id"].Value + "";
            string id_zaholovky_postach = dataGridView1.Rows[dataGridView1.CurrentRow.Index].Cells["id"].Value + "";
            string m_id = comboBox6.SelectedValue + "";
            if (m_id == "") m_id = "0";
            string kilkist = textBox5.Text;
            string price = textBox6.Text;

            Int32 old_m_id = read_integer_data("select `id_materialy` from `punkty_postach` where `id` = '" + id + "'");

            Int32 sklad_kilk = read_integer_data("SELECT COALESCE( sum(`sklad`.`kilkist`), 0) as `kilkist` from `sklad` where `sklad`.`id_materialy` = '" + m_id + "'");
            Int32 old_sklad_kilk = read_integer_data("SELECT COALESCE( sum(`sklad`.`kilkist`), 0) as `kilkist` from `sklad` where `sklad`.`id_materialy` = '" + old_m_id.ToString() + "'");

            Int32 new_kilkist = Convert.ToInt32(kilkist);
            Int32 old_kilk = read_integer_data("SELECT `kilkist` from `punkty_postach` where `id` = '" + id + "'");

            Int32 zalyshok = 0;
            if (old_m_id.ToString() != m_id)
            {

            }
            else
            {
                zalyshok = sklad_kilk - old_kilk + new_kilkist;
            }

            if (old_m_id.ToString() != m_id)
            {

                run_query("UPDATE  `sklad` SET `kilkist`= `kilkist` + '" + old_kilk.ToString() + "' WHERE `id_materialy`=" + old_m_id.ToString() + ";");
            }
            run_query("UPDATE  `sklad` SET `kilkist`='" + zalyshok.ToString() + "' WHERE `id_materialy`=" + m_id + ";");

            run_query("UPDATE `punkty_postach` SET `id_materialy`='" + m_id + "',`kilkist`='" + kilkist + "',`price`='" + price + "' WHERE `id`=" + id + "");
            fill_grid("SELECT `punkty_postach`.`id`," +
                       " `materialy`.`material` as 'material',`punkty_postach`.`kilkist`,`punkty_postach`.`price`, " +
                       "`materialy`.`id` as 'm_id', " +
                       " `punkty_postach`.`id_zaholovky_postach` from `punkty_postach` " +


                       "JOIN `materialy` on `materialy`.`id`=`punkty_postach`.`id_materialy` " +
                        "WHERE `punkty_postach`.`id_zaholovky_postach` = " + id_zaholovky_postach, dataGridView2,

                new string[] { "m_id", "id_zaholovky_postach", "id" },//перелічуємо назви стовпців, які потрібно приховати

                new string[] { "material", "kilkist", "price" },//перелічуємо назви стовпців транслітом
                new string[] { "Матеріал", "Кількість", "Ціна" });
            comboBox6.Text = ""; textBox5.Text = ""; textBox6.Text = "";
            button8_Click(this, null);
        }

        private void button8_Click(object sender, EventArgs e)
        {
            comboBox6.Text = ""; textBox5.Text = ""; textBox6.Text = "";

            enable_components(new Control[] { dataGridView2, dataGridView1, tabControl1, tabPage2, tabPage1 });
        }

        private void видалитиToolStripMenuItem_Click(object sender, EventArgs e)
        {

            string id = dataGridView1.Rows[dataGridView1.CurrentRow.Index].Cells["id"].Value + "";
            string id_zaholovky_postach = dataGridView1.Rows[dataGridView1.CurrentRow.Index].Cells["id"].Value + "";
            string data = dataGridView1.Rows[dataGridView1.CurrentRow.Index].Cells["data"].Value + "";
            if ((id != "") && (alert_message("Ви дійсно бажаєте видалити замовлення від " + data + " ?", "Питання")))
            {
                run_query("DELETE FROM `zaholovky_postach` WHERE `id`=" + id + ";");
                run_query("DELETE FROM `punkty_postach` WHERE `id_zaholovky_postach`=" + id_zaholovky_postach + ";");
                fill_grid("SELECT `zaholovky_postach`.`id`," +
                         "`providers`.`Name` as 'providers', `personal`.`Name` as 'personal',`zaholovky_postach`.`summ`,`zaholovky_postach`.`data`, " +
                         "`providers`.`id` as 'bid', " +
                         "`personal`.`id` as 'pid' FROM `zaholovky_postach` " +

                         "JOIN `providers` on `providers`.`id`=`zaholovky_postach`.`id_provider` " +

                         "JOIN `personal` on `personal`.`id`=`zaholovky_postach`.`id_personal`;", dataGridView1,

             new string[] { "bid", "pid", "id" },//перелічуємо назви стовпців, які потрібно приховати

                  new string[] { "providers", "personal", "summ", "data" },//перелічуємо назви стовпців транслітом
                  new string[] { "Постачальники", "Співробітник", "Сума", "Дата" });
            }
        }

        private void видалитиToolStripMenuItem1_Click(object sender, EventArgs e)
        {
            string id = dataGridView2.Rows[dataGridView2.CurrentRow.Index].Cells["id"].Value + "";

            string price = dataGridView2.Rows[dataGridView2.CurrentRow.Index].Cells["price"].Value + "";
            if ((id != "") && (alert_message("Ви дійсно бажаєте видалити запис постачання на суму " + price + " ?", "Питання")))
            {
                run_query("DELETE FROM `punkty_postach` WHERE `id`=" + id + ";");
                fill_grid("SELECT `punkty_postach`.`id`," +
                      " `materialy`.`material` as 'material',`punkty_postach`.`kilkist`,`punkty_postach`.`price`, " +
                      "`materialy`.`id` as 'm_id', " +
                      " `punkty_postach`.`id_zaholovky_postach` from `punkty_postach` " +


                      "JOIN `materialy` on `materialy`.`id`=`punkty_postach`.`id_materialy` " +
                       "WHERE `punkty_postach`.`id_zaholovky_postach` = " + id, dataGridView2,

               new string[] { "m_id", "id_zaholovky_postach", "id" },//перелічуємо назви стовпців, які потрібно приховати

               new string[] { "material", "kilkist", "price" },//перелічуємо назви стовпців транслітом
               new string[] { "Матеріал", "Кількість", "Ціна" });
                dataGridView1_CellContentClick(this, null);
            }
        }

        private void додатиToolStripMenuItem_Click(object sender, EventArgs e)
        {
            show_components(new Control[] { tabControl1, tabPage1 });//показуємо панель вкладок, та кнопку відмінити редагування
            disable_components(new Control[] { dataGridView2, dataGridView1, tabControl2, tabPage2 });//блокуємо сітку, вкладку редагувати, панель пошуку
        }
    }
    }


